package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public class MethodParameter implements Cloneable
{
    private int name_index;
    private int access_flags;
    
    public MethodParameter() {
    }
    
    MethodParameter(DataInput input) throws IOException {
        this.name_index = input.readUnsignedShort();
        this.access_flags = input.readUnsignedShort();
    }
    
    public int getNameIndex() {
        return this.name_index;
    }
    
    public void setNameIndex(int name_index) {
        this.name_index = name_index;
    }
    
    public String getParameterName(ConstantPool constant_pool) {
        if (this.name_index == 0) {
            return null;
        }
        return ((ConstantUtf8)constant_pool.getConstant(this.name_index, (byte)1)).getBytes();
    }
    
    public int getAccessFlags() {
        return this.access_flags;
    }
    
    public void setAccessFlags(int access_flags) {
        this.access_flags = access_flags;
    }
    
    public boolean isFinal() {
        return (this.access_flags & 0x10) != 0x0;
    }
    
    public boolean isSynthetic() {
        return (this.access_flags & 0x1000) != 0x0;
    }
    
    public boolean isMandated() {
        return (this.access_flags & 0xFFFF8000) != 0x0;
    }
    
    public final void dump(DataOutputStream file) throws IOException {
        file.writeShort(this.name_index);
        file.writeShort(this.access_flags);
    }
    
    public MethodParameter copy() {
        try {
            return (MethodParameter)this.clone();
        }
        catch (CloneNotSupportedException ex) {
            return null;
        }
    }
}
